exec("./stock_resources.cs");
//1.0e+999 = unsexagintasescentiillion
if($pref::CustomSpells::storeOnPlayer $= "")
	$pref::CustomSpells::storeOnPlayer = false;

if($pref::CustomSpells::manaTickRate $= "")
	$pref::CustomSpells::manaTickRate = 1000;

if($pref::CustomSpells::manaBurn $= "")
	$pref::CustomSpells::manaBurn = "2.0";

if($pref::CustomSpells::requireSpellBuying $= "")
	$pref::CustomSpells::requireSpellBuying = true;

if($pref::CustomSpells::defaultSpellTimeout $= "")
	$pref::CustomSpells::defaultSpellTimeout = 0.5;

//
// MAIN FUNCTIONS
//

function servercmdcast(%client, %name, %animate)
{
	if(!isobject(%client.player))
	{
		return false;
	}

	if(%client.player.lastSpellCastTime > $sim::Time - $pref::CustomSpells::defaultSpellTimeout)
	{
		//messageClient(%client, '', "You're already casting another spell!");
		return false;
	}
		
	%name = strlwr(%name); //Keep things consistent by going all lower-case.

	if(!isObject($spellName[%name]))
	{
		messageClient(%client,'',"You don't know of such a spell!");
		return false;
	}
	
	if(!%client.ownedSpell[%name] && $pref::CustomSpells::requireSpellBuying)
	{
		messageClient(%client,'',"You don't know of such a spell!");
		return false;
	}
	
	if(!%client.player.isUsingMana)
	{
		%client.player.Mana = 100;
		%client.player.Manaloop();
		%client.player.isUsingMana = true;
		if(%client.player.getdatablock().isMage)
			%client.player.isOldWizzard = true;
			
		if(%max = %client.player.getDatablock().maxMana !$= "")
			%client.player.maxMana = %max;
			
		else
			%client.player.maxMana = 100;
	}
	
	messageClient(%client, '', "\c2Casting\c4" SPC %name @ "\c2.");
	
	if(%animate)
		%client.player.playThread(2, "armAttack");
	
	%client.player.lastSpellCastTime = $sim::time;
	
	%spell = $spellName[%name];
	
	%lineNum = 0;
	
	for(%i = 0; %i < %spell.commandCount; %i++)
	{
		%line = %spell.command[%i];
		
		if(%line $= "" || getFieldCount(%line) < 2)
		{
			announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
			announce("Spell Error: Not enough arguments.");
			continue;
		}

		%delay = getField(%line, 0);
		%command = getField(%line, 1);
		
		if(%delay > %highestDelay)
			%highestDelay = %delay;
		
		// echo(%command);
		
		switch$(%command)
		{
			case "projectile": // INT Initial velocity of the projectile. STRING Name of the projectileData Datablock to be spawned. VECTOR Parameters for randomized velocity from caster. FLOAT Scale of the projectile.
				%power = getField(%line, 2);
				%datablock = nametoID(getField(%line, 3));
				%scale = getField(%line, 5);
				%randVector = getField(%line, 4);
				
				if(%datablock <= 0)
				{
					announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
					announce("Spell Error: Invalid Projectile datablock. Are the required add-ons enabled? Check spelling.");
				}
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "SpawnProjectile", %power, %datablock, %randVector, %scale);
				
			case "explode": // STRING Name of the projectileData Datablock to be used, the explosion will be the explosion assigned to that projectile. FLOAT Scale of the explosion.
				%datablock = getField(%line, 2);
				%scale = getField(%line, 3);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "SpawnExplosion", %datablock, %scale);
				
			case "effectprojectile":
				%power = getField(%line, 2);
				%datablock = nametoID(getField(%line, 3));
				%scale = getField(%line, 4);
				//%randVector = parseSpellSyntax(getField(%line, 4));
				%effect = getField(%line, 5);
				%mask = getField(%line, 6);
				
				if(%datablock <= 0)
				{
					announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
					announce("Spell Error: Invalid Projectile datablock. Are the required add-ons enabled? Check spelling.");
				}
				
				if(%mask $= "")
					%mask = $typeMasks::playerObjectType;
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "createEffectProjectile", %power, %datablock, %scale, %effect, %mask);
			
			case "addhealth": // INT Amount of health to be added to the player (negative value will deal damage).
				%amount = getField(%line, 2);
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "AddHealth", %amount);
				
			case "setDatablock": // STRING datablock name to change to
			
				%datablock = nameToID(getField(%line, 2));
				
				if(!isObject(%datablock))
				{
					announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
					announce("Spell Error: Invalid player datablock. Are the required add-ons enabled? Check spelling.");
					continue;
				}
				
				%client.spellSchedule[%linenum] = %client.player.setDatablock(%datablock);
				
			case "radiusfreeze": // INT Radius of the freeze in TU. INT Duration of the freeze in seconds. BOOL Whether or not the caster will be affected.
				%radius = getField(%line, 2);
				%duration = getField(%line, 3);
				%effectCaster = getField(%line, 4);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "magicRadiusFreeze", %radius, %duration, %effectCaster);
				
			case "radiusburn": // INT Radius of the burn in TU. INT Duration of the burn in seconds. BOOL Whether or not the caster will be affected.
				%radius = getField(%line, 2);
				%duration = getField(%line, 3);
				%effectCaster = getField(%line, 4);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "magicRadiusBurn", %radius, %duration, %effectCaster);
				
			case "radiusdamage": // INT Radius of the damage in TU. INT Damage to be inflicted on affected targets. BOOL Whether or not the caster will be affected.
				%radius = getField(%line, 2);
				%magnatude = getField(%line, 3);
				%effectCaster = getField(%line, 4);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "magicRadiusDamage", %radius, %magnatude, %effectCaster);
				
			case "radiusvelocity": // INT Radius of the damage in TU. INT Damage to be inflicted on affected targets. BOOL Whether or not the caster will be affected.
				%radius = getField(%line, 2);
				%velocity = parseSpellSyntax(getField(%line, 3));
				%effectCaster = getField(%line, 4);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, "magicRadiusVelocity", %radius, %velocity, %effectCaster);
				
			case "playsound": // STRING Name of the audioData datablock to be played.
				%sound = getField(%line, 2);
				%position = %client.player.getPosition();
				
				%client.spellSchedule[%linenum] = schedule(%delay, %client.player, "serverPlay3D", %sound, %position);
				
			case "clientplaysound": // STRING Name of the audioData Datablock to be played.
				%sound = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.schedule(%delay, "Play2D", %sound);
				
			case "intcost": // INT Amount of mana to check and remove from the player. If the amount cannot be paid, the spell is cancelled and no mana is paid.
				%cost = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, intCost, %cost);
				
				
			case "intcostnoreduction": // INT Amount of mana to check the player for. If the amount could not be paid, the spell is cancelled.
				%cost = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, intCostNoReduction, %cost);
				
			case "taxmana": // INT Amount of mana to be removed from the player. This amount will always be paid. See Manaburn.
				%cost = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, taxMana, %cost);
				
			case "setspelldelay": // INT Time in seconds to delay the next spell cast, 0 will allow new spells to be cast immediately (don't do this). NOTE: The default spell delay is half a second.
				%time = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, setSpellDelay, %time);
				
			case "setScale": // FLOAT scale to set the player to
				%scale = getField(%line, 2);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, setPlayerScale, %scale);
				
			case "setCloaking": // FLOAT Value between 0 and 1 to determine transparency, with 1 being invisible. INT Time in milliseconds for the effect to last.
				%amount = getField(%line, 2);
				%duration = getField(%line, 3);
				
				%client.spellSchedule[%linenum] = %client.player.setCloaking(%amount, %duration);
				
			case "negate": // No arguments
				%client.spellSchedule[%linenum] = %client.player.cancelScheduledSpellEffects();
				
			case "protection": // STRING Type of protection 'direct' or 'reduction'. INT or FLOAT Magnitude of specified effect, INT for direct, FLOAT for reduction. INT Duration of shields in seconds.
				%type = getField(%line, 2);
				%amount = getField(%line, 3);
				%duration = getField(%line, 4);
				
				if(!%type $= "direct"  || !%type $= "reduction")
				{
					announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
					announce("Spell Error: Invalid protection type. REMINDER: 'direct' or 'reduction'");
					return;
				}
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, setMagicProtection, %type, %amount, %duration);
				
				
				
			case "effect": // STRING Type of effect. Parameters vary.
				%type = getField(%line, 2);
				%time = getField(%line, 3);
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, magicEffect, %type, %time, %lineNum, %name);
				
			case "fortifymana": // INT Amount of mana to be fortified. INT Duration of effect in seconds.
				%amount = getField(%line, 2);
				%duration = getField(%line, 3);
				//MOVE THIS TO METHOD
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, fortifyMana, %amount, %duration);
				
			case "scripteffect": // STRING Name of function to be called. STRING 'client' or 'player' or 'closestplayer' as target to be called.
				%function = getField(%line, 2);
				%target = getField(%line, 3);
				
				
				if(!isFunction(%function))
				{
					announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
					announce("Spell Error: Invalid function. REMINDER: You cannot use methods!");
					return;
				}
				
				%client.spellSchedule[%linenum] = %client.player.schedule(%delay, magicScriptEffect, %function, %target, %lineNum, %name);
				
				

			default:
				announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
				announce("Spell Error: Unrecognised command.");
				return;
		}
		
		%lineNum++;
	}
	
	if(%highestDelay > 5000)
	{
		schedule(%highestDelay, %client.player, messageClient, %client, '', %name SPC "spell completed.");
	}
	
	%client.player.schedule(%highestDelay, playThread, 2, "root");
	%client.spellScheduleMax = %lineNum +1;
	
	%client.player.onSpellFinished(%name, $spellName[%name], %highestDelay);
	return 1;
}

function servercmdsetautocast(%client, %spell)
{
	if($spellname[%spell] $= "")
		return;
		
	%client.spellAutoCast = %spell;
	
	messageClient(%client, '', "Autocast spell set to" SPC %spell @ ".");
}

function servercmdlistSpells(%client)
{
	if(%client.allOwnedSpells $= "" && %client.player.allOwnedSpells $= "")
	{
		%client.chatMessage("You currently know no spells! Once you learn a spell, you can do /cast <spellname>. If you have a magic staff, you can do /setAutoCast <spellname> to cast your spell from the staff.");
		return;
	}
	
	if(%client.allOwnedSpells $= "")
		%target = %client.player;
	else
		%target = %client;
		
	%num = getFieldCount(%target.allOwnedSpells);
	
	%client.chatMessage("\c3You quickly recount your memories of the arcane arts.");
	
	%split=0;
	
	for(%i = 0; %i < %num; %i++)
	{
		%spellname = getField(%target.allOwnedSpells, %i);
		
		%line[%split] = %line[%split] SPC %spellName;
		
		if(getWordCount(%line[%split]) > 4)
			%split++;
	}
	
	for(%i = 0; %line[%i] !$= ""; %i++)
	{
		%client.chatMessage("\c6" @ %line[%i]);
	}
	
	if(%split > 5)
		%client.chatMessage("If this list is too long, you can press the PageUP key to navigate the higher lines.");
}

function player::onSpellFinished(%this, %spellname, %spellfile, %spellDuration)
{
	//Do nothing.
	//This is here so you can package it.
}

function parseSpellSyntax(%line) // Used to parse vectors. e.g. '15|5|50' instead of '15 5 50'.
{
	%line = strReplace(%line, "|", " ");
	
	return %line;
}

function registerSpell(%file) // Required to create a new spell.
{
	if(isFile(%file) && fileExt(%file) $= ".txt")
	{
		%name = fileBase(%file);
		
		%spell = new ScriptObject(SpellObjectType)
		{
			sourceFile = %file;
		};
		
		%fileObject = new FileObject(){};
		%fileObject.openForRead(%file);
		
		%commandCount = 0;
		while(!%fileObject.isEOF())
		{
			%line = %fileObject.readLine();
			
			if(%line $= "OLDFORMAT")
				%spell.oldFormat = true;
			
			%spell.command[%commandCount] = %line;
			%commandCount++;
		}
		
		%spell.commandCount = %commandCount - 1;
		
		$spellName[%name] = %spell;
		echo("Registered" SPC %name SPC "spell. File:" SPC %file);
	}
}

//
// EVENTS
// 

registerOutputEvent("gameconnection", buySpell, "STRING 100 150", 0);

function gameConnection::buySpell(%this, %string)
{
	if(!isObject(%this.player))
		return;
		
	if($SpellName[%string] $= "")
	{
		messageClient(%this, '', "That is not a valid spell.");
		return;
	}
	

	if($pref::CustomSpells::storeOnPlayer && !%this.player.ownedSpell[%string])
	{
		%this.player.ownedSpell[%string] = true;
		if(%this.player.allOwnedSpells $= "")
			%this.player.allOwnedSpells = %string;
		else
			%this.player.allOwnedSpells = %this.player.allOwnedSpells TAB %string;
		messageClient(%this, '', "\c3You have learned the\c4" SPC %string SPC "\c3spell!");
	}
	
	else if(!%this.ownedSpell[%string])
	{
		%this.ownedSpell[%string] = true;
		if(%this.allOwnedSpells $= "")
			%this.allOwnedSpells = %string;
		else
			%this.allOwnedSpells = %this.allOwnedSpells TAB %string;
		messageClient(%this, '', "\c3You have learned the\c4" SPC %string SPC "\c3spell!");
	}
	
	else
	{
		//messageClient(%this, '', "\c3You already know the\c4" SPC %string SPC "\c3spell.");
		return;
	}
	
	
}

//
// METHODS
//

function player::createEffectProjectile(%this, %power, %datablock, %scale, %effect, %mask)
{
	if(!isobject(%datablock))
		return;
		
	if(%mask $= "")
		%mask = $typemasks::playerObjectType;
		
	%projectile = %datablock;
	%spread = 0.00;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %power);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new projectile()
		{
			dataBlock = %projectile;
			initialVelocity = %power;
			initialPosition = %this.getEyePoint();
			sourceObject = %this;
			sourceSlot = 0;
			client = %this.client;
			isaEffectProjectile = true;
			maskDetect = %mask;
			magicEffect = %effect;
		};
		MissionCleanup.add(%p);
	}
	return %p;
	
}

function player::intCost(%this, %cost)
{
	if(%this.mana < %cost)
	{
		//messageClient(%this.client, '', "You don't have enough mana!");
		%this.client.centerPrint("You don't have enough mana!", 1);
		%this.cancelScheduledSpellEffects();
		return;
	}
	
	%this.mana -= %cost;
}

function player::intCostNoReduction(%this, %cost)
{
	if(%this.mana < %cost)
	{
		//messageClient(%this.client, '', "You don't have enough mana!");
		%this.client.centerPrint("You don't have enough mana!", 1);
		%this.cancelScheduledSpellEffects();
		return;
	}
}

function player::taxMana(%this, %cost)
{
	%this.mana -= %cost;
}

function player::cancelScheduledSpellEffects(%this)
{
	for(%i = 0; %i<%this.client.spellScheduleMax; %i++)
	{
		if(isEventPending(%this.client.spellSchedule[%i]))
		{
			echo("cancelled an effect...");
			cancel(%this.client.spellSchedule[%i]);
		}
	}
}

function player::setSpellDelay(%this, %time)
{
	%this.lastSpellCastTime += %time;
}

function player::setMagicProtection(%this, %type, %amount, %duration)
{
	if(%type $= "direct")
	{
		%this.magicShields += %amount;
		
		if(%duration >= 0)
			%this.schedule(%duration*1000, removeMagicShields, 0, %amount);
	}
	
	else if(%type $= "reduction")
	{
		%this.damageReduction -= %amount;
		
		if(%duration >= 0)
			%this.schedule(%duration*1000, removeMagicShields, 1, %amount);
	}
}

function player::magicEffect(%this, %type, %time, %lineNum, %name)
{
	%client = %this.client;
	
	switch$(%type)
	{
		case "shinespinnything":
			%effect = new StaticShape()
			{
				datablock = mages_auraGlowWhiteEffect;
				position = %this.getPosition();
			};
			
			
			%effect.playThread(0, "castAnim");
			%effect.schedule(%time, delete);
			
		case "heal":
			%this.mountImage(healImage, 3);
			%this.schedule(%time, unMountImage, 3);
			
		case "glow":
			%this.mountImage(glowImage, 3);
			%this.schedule(%time, unMountImage, 3);
	
		default:
			announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
			announce("Spell Error: Invalid effect. Refer to documentation.");
	}
}

function player::magicScriptEffect(%this, %function, %target, %lineNum, %name)
{
	if(%target $= "client")
		%target = %this.client;
		
	else if(%target $= "player")
		%target = %this;
		
	else if(%target $= "closestplayer")
	{
		initContainerRadiusSearch(%this.player.getposition(), 200, $typeMasks::PlayerObjectType);
		
		%target = containerSearchNext();
		
		if(%target == %this)
			%target = containerSearchNext();
		
		if(%target == 0)
			return;
	}
	
	else
	{
		announce("Spell Error on line" SPC %lineNum SPC "in spell file" SPC $spellName[%name]);
		announce("Spell Error: Incorrect target. REMINDER: 'client', 'player', or 'closestplayer'");
		return;
	}
	
	call(%function, %target);
}

function player::fortifyMana(%this, %amount, %duration)
{
	%this.manaMax += %amount;

	%this.schedule(%duration*1000, manaFortifyFallback, %amount);
}

function player::setCloaking(%this, %amount, %duration)
{
	%this.setNodeColor("ALL", "0 0 0" SPC %amount);
	%this.isHidden = true;
	
	%this.schedule(%duration, endCloaking);
}

function player::endCloaking(%this)
{
	%this.client.applyBodyColors();
	%this.isHidden = false;
}

function player::stopAllMovement(%this, %duration)
{
	if(isobject(%this.freezeZone))
		return;
	
	%this.setVelocity("0 0 0");
	%this.freezeZone = new PhysicalZone()
	{
		position = vectorAdd(%this.getTransform(), "0 0 0.5");
		scale = "0.8 0.8 0.8";
		velocityMod = 0;
		gravityMod = 0;
		extraDrag = 32;
		polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
	};
	%this.freezeZone.activate();
	
	%this.freezeZone.schedule(%duration, delete);
}

function player::manaLoop(%this)
{
	if(!isobject(%this.client))
		return;
		
	if(%this.mana < 0)
		%this.addHealth($pref::customSpells::manaBurn*-1);
		
	%this.mana++;

	if(%this.mana > %this.maxMana && %this.mana < %this.maxMana + 1)
		%this.mana = %this.maxMana;
	else if(%this.mana > %this.maxMana)
		%this.mana--;
		
	
		
	if(%this.player.isOldWizzard)
		%this.energy = %this.mana;
		
	if(%this.player.damageReduction $= "")
		%this.player.damageReduction = 1;
		
		
	%this.schedule($pref::CustomSpells::manaTickRate, manaLoop);
}

function player::magicRadiusDamage(%this, %radius, %amount, %affectCaster)
{
	if(%affectCaster)
		%this.addHealth(%amount*-1);
		
	initContainerRadiusSearch(%this.getPosition(), %radius, $typeMasks::PlayerObjectType);
	
	%search = containerSearchNext();
	
	while(isObject(%search))
	{
		if(%search == %this)
			continue;
		
		if(minigamecandamage(%this, %search))
			%search.damage(%this, %this.getPosition(), %amount*-1, $damageType::default);
			
		%search = containerSearchNext();
	}
}

function player::magicRadiusBurn(%this, %radius, %amount, %affectCaster)
{
	if(%affectCaster)
	{
		%this.burnPlayer(%amount);
		%this.magicBurnLoop(%amount);
	}
		
	initContainerRadiusSearch(%this.getPosition(), %radius, $typeMasks::PlayerObjectType);
	
	%search = containerSearchNext();
	
	while(isObject(%search))
	{
		if(%search == %this)
			continue;
		
		if(minigamecandamage(%this, %search))
		{
			%search.burnPlayer(%amount);
			%search.magicBurnLoop(%amount, %this);
		}
		
		%search = containerSearchNext();
	}
}

function player::magicBurnLoop(%this, %duration, %sourcePlayer)
{
	%this.damage(%sourcePlayer, %sourcePlayer.getPosition(), -10, $damageType::default);
	if(%duration > 1)
		%this.schedule(1000, magicBurnLoop, %duration-1);
}

function player::magicRadiusFreeze(%this, %radius, %amount, %affectCaster)
{
	if(%affectCaster)
	{
		%this.magicFreeze(%amount);
	}
		
	initContainerRadiusSearch(%this.getPosition(), %radius, $typeMasks::PlayerObjectType);
	
	%search = containerSearchNext();
	
	while(isObject(%search))
	{
		if(%search == %this)
			continue;
		
		if(minigamecandamage(%this, %search))
			%search.magicFreeze(%amount);
			
		%search = containerSearchNext();
	}
}

function player::magicFreeze(%this, %amount)
{
	if(!isObject(%this))
		return;

	%this.client.setControlObject(%this.client.camera);
	%this.client.camera.setMode("Corpse", %this);
	%datablock = %this.getDatablock();
	%this.setDatablock(PlayerNoMoveArmor);
	%this.setNodeColor("ALL", "0.6 0.7 1 1");
	%this.schedule(%amount*1000, unMagicFreeze, %datablock);
}

function player::unMagicFreeze(%this, %returnData)
{
	%this.client.setControlObject(%this);
	%this.setDatablock(%returnData);
	%this.client.applyBodyColors();
}

function player::removeMagicShields(%this, %type, %amount)
{
	switch(%type)
	{
		case 0:
			%this.magicShields -= %amount;
			if(%this.magicShields < 0)
				%this.magicShields = 0;
				
		case 1:
			%this.damageReduction += %amount;
	}

}

function player::manaFortifyFallback(%this, %amount)
{
	%this.maxMana -= %amount;
}


//
//Package(s)
//

package magicSpellsSystemPackage
{
	function player::damage(%obj, %pos, %directDamage, %damageType) // This packaged function controls the effects of protection spells.
	{
		if(!%obj.magicShields && !%obj.damageReduction)
		{
			return parent::damage(%obj, %pos, %directDamage, %damageType);
		}
		
		if(%obj.damageReduction)
		{
			%directDamage *= %obj.damageReduction;
		}
		
		
		%origionalDamage = %directDamage;
		%directDamage -= %obj.magicShields;
		%obj.magicShields -= %origionalDamage;
		
		if(%obj.magicShields < 0)
		{
			%directDamage -= %obj.magicShields;
			%obj.magicShields = 0;
			
			if(%obj.getMountedImage(3) == nameToID("glowImage"))
				%obj.unMountImage(3);
		}
		
		
		return parent::damage(%obj, %pos, %directDamage, %damageType);
	}
	
	// function ProjectileData::onCollision(%this, %projectile, %col, %a, %vec, %vec1, %vec2)
	// {
		// parent::onCollision(%this, %projectile, %col, %a, %vec, %vec1, %vec2);
		// if(!%projectile.isaeffectprojectile)
		// {
			
			// return;
		// }
		
		// else if(!%col.getType() & %projetile.maskDetect)
		// {
			// parent::onCollision(%this, %projectile, %col, %a, %vec, %vec1, %vec2);
			// return;
		// }
		
		// %effect = %projectile.magicEffect;
		
		// %base = firstWord(%effect);
		
		// switch$(%base)
		// {
			// case "cancel":
				// %col.cancelScheduledSpellEffects();
		// }
	// }
};

activatePackage(magicSpellsSystemPackage);