//Essentials

if(!isobject(PlayerNoMoveArmor)) //Don't need to make it twice if they're using Elemental Spells.
{
	datablock PlayerData(PlayerNoMoveArmor : PlayerStandardArmor)
	{
		airControl = 0;
		jumpForce = 0;
		runForce = 0;
		maxForwardSpeed = 0;
		maxSideSpeed = 0;
		maxBackwardSpeed = 0;
		maxForwardCrouchSpeed = 0;
		maxSideCrouchSpeed = 0;
		maxBackwardCrouchSpeed = 0;
		jumpSound = "";
		canRide = false;
		canJet = false;
		cameraDefaultFov = 90;
		cameraMaxFov = 90;
		cameraMinFov = 90;
		uiName = "";
	};
}


function HealImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock itemData(magicStaffBaseItem)
{
	category = "Tools";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./resources/staff.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Magic Staff";
	iconName = "./resources/icon_staff";
	doColorShift = true;
	//colorShiftColor = "0 0 0";
	

	 // Dynamic properties defined by the scripts
	image = magicStaffBaseImage;
	canDrop = true;
};

datablock ShapeBaseImageData(magicStaffBaseImage)
{
   // Basic Item properties
   shapeFile = "./resources/staff.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.7 1.2 -0.15";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = magicStaffBaseItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   doColorShift = true;
   colorShiftColor = magicStaffBaseItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Fire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateSequence[3]				= "Fire";
   stateTransitionOnTriggerUp[3]	= "StopFire";
   stateSound[3] = pushBroomSwingSound;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
   stateSound[4] = pushBroomSwingSound;

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};

function magicStaffBaseImage::onFire(%this, %obj, %slot)
{
	if(%obj.client.spellAutocast !$= "")
	{
		servercmdcast(%obj.client, %obj.client.spellAutocast, true);
	}
	else
	{
		%obj.client.centerPrint("You must set a spell to autocast!<br>Do <color:ffffff>/setautocast <color:a0a0a0><spellname>",1);
	}
}

// Effects

datablock StaticShapeData(mages_auraGlowWhiteEffect)
{
	category = "Effects";
	shapeFile = "./resources/effect_auraglow.dts";
};

function effect_auraGlow::onAdd(%data, %obj)
{
	%obj.playThread(0, "castAnim");
	%obj.schedule(5000, "delete");
}

// Sound

datablock AudioProfile(Magic_FairyDustSound)
{
	filename = "./resources/fairyDust.wav";
	description = AudioClose3D;
	preload = true;
};

//Emitters

datablock ParticleData(magic_goldSparkleParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/lighting/flare";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "1 1 1 0.8";
  colors[1] = "1 0.9 0.5 1";
  colors[2] = "1 0.8 0.3 1";
  colors[3] = "1 1 1 0";
  sizes[0] = 0;
  sizes[1] = 2;
  sizes[2] = 0.5;
  sizes[3] = 0.5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 0.2;
  times[3] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(magic_goldSparkleEmitter)
{
  uiName = "Gold Sparkle";
  ejectionPeriodMS = 25;
  periodVarianceMS = 20;
  ejectionVelocity = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "magic_goldSparkleParticle";
  useEmitterColors = 0;
};

datablock ParticleData(magic_azureSparkleParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/lighting/flare";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "0.8 1 1 1";
  colors[1] = "0.5 0.8 1 1";
  colors[2] = "0.3 0.7 1 1";
  colors[3] = "1 1 1 0";
  sizes[0] = 0;
  sizes[1] = 2;
  sizes[2] = 0.5;
  sizes[3] = 0.5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 0.2;
  times[3] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(magic_azureSparkleEmitter)
{
  uiName = "Azure Sparkle";
  ejectionPeriodMS = 25;
  periodVarianceMS = 20;
  ejectionVelocity = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "magic_azureSparkleParticle";
  useEmitterColors = 0;
};

//PINK AHEAD

datablock ParticleData(magic_pinkSparkleParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/lighting/flare";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "1 1 1 1";
  colors[1] = "1 0.5 0.9 1";
  colors[2] = "1 0.3 0.8 1";
  colors[3] = "1 1 1 0";
  sizes[0] = 0;
sizes[1] = 2;
  sizes[2] = 0.5;
  sizes[3] = 0.5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 0.2;
  times[3] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(magic_pinkSparkleEmitter)
{
  uiName = "Pink Sparkle";
  ejectionPeriodMS = 25;
  periodVarianceMS = 20;
  ejectionVelocity = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "magic_pinkSparkleParticle";
  useEmitterColors = 0;
};

// if(!isObject(healParticle))
// {
	datablock ParticleData(HealParticle)
	{
	   dragCoefficient      = 5.0;
	   gravityCoefficient   = -0.2;
	   inheritedVelFactor   = 0.0;
	   constantAcceleration = 0.0;
	   lifetimeMS           = 1000;
	   lifetimeVarianceMS   = 500;
	   useInvAlpha          = false;
	   textureName          = "./resources/heal";
	   colors[0]     = "1.0 1.0 1.0 1";
	   colors[1]     = "1.0 1.0 1.0 1";
	   colors[2]     = "0.0 0.0 0.0 0";
	   sizes[0]      = 0.4;
	   sizes[1]      = 0.6;
	   sizes[2]      = 0.4;
	   times[0]      = 0.0;
	   times[1]      = 0.2;
	   times[2]      = 1.0;
	};

	datablock ParticleEmitterData(HealEmitter)
	{
	   ejectionPeriodMS = 35;
	   periodVarianceMS = 0;
	   ejectionVelocity = 0.5;
	   ejectionOffset   = 1.0;
	   velocityVariance = 0.49;
	   thetaMin         = 0;
	   thetaMax         = 120;
	   phiReferenceVel  = 0;
	   phiVariance      = 360;
	   overrideAdvance = false;
	   particles = "HealParticle";

	   uiName = "Emote - Heal";
	};
	
	datablock ShapeBaseImageData(HealImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $HeadSlot;

		stateName[0]					= "Ready";
		stateTransitionOnTimeout[0]		= "FireA";
		stateTimeoutValue[0]			= 0.01;

		stateName[1]					= "FireA";
		stateTransitionOnTimeout[1]		= "Done";
		stateWaitForTimeout[1]			= True;
		stateTimeoutValue[1]			= 0.350;
		stateEmitter[1]					= HealEmitter;
		stateEmitterTime[1]				= 0.350;

		stateName[2]					= "Done";
		stateScript[2]					= "onDone";
	};
// }

datablock ParticleData(GlowParticle)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 250;
   useInvAlpha          = false;
   textureName          = "base/data/particles/dot";
   colors[0]     = "1.0 1.0 1.0 1";
   colors[1]     = "1.0 1.0 1.0 0.5";
   colors[2]     = "0.0 0.0 0.0 0";
   sizes[0]      = 0.0;
   sizes[1]      = 0.8;
   sizes[2]      = 0.0;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(GlowEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   ejectionOffset   = 0.75;
   velocityVariance = 0.49;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GlowParticle";
};

datablock ShapeBaseImageData(GlowImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= GlowEmitter;
	stateEmitterTime[1]				= 0.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

datablock ParticleData(magic_fireParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 150;
	textureName = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "1.0 0.4 0.0 0.9";
	colors[1]     = "1.0 0.5 0.0 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(magic_fireEmitter)
{
   ejectionPeriodMS = 70;
   periodVarianceMS = 60;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "magic_fireParticle";

   uiName = "";
};

datablock ParticleData(magic_IceParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 3.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 250;
	textureName = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "0.1 0.4 1.0 0.9";
	colors[1]     = "0.0 0.5 1.0 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(magic_IceEmitter)
{
   ejectionPeriodMS = 70;
   periodVarianceMS = 60;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "magic_IceParticle";

   uiName = "";
};

datablock ParticleData(magic_DarkParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 50;
	textureName = "base/data/particles/dot";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.2 0.0 0.2 1.0";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(magic_DarkEmitter)
{
   ejectionPeriodMS = 170;
   periodVarianceMS = 60;
   ejectionVelocity = 3.0;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "magic_DarkParticle";

   uiName = "";
};

datablock ParticleData(magic_LightParticle)
{
	dragCoefficient      = 0.1;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.2;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 50;
	textureName = "base/data/particles/dot";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "1.0 1.0 0.8 1.0";
	colors[1]     = "1.0 1.0 0.8 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleEmitterData(magic_LightEmitter)
{
   ejectionPeriodMS = 40;
   periodVarianceMS = 20;
   ejectionVelocity = 3.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "magic_lightParticle";

   uiName = "";
};

//Explosions

datablock ExplosionData(magic_fireballExplosion)
{
	//explosionShape = "./explosionSphere1.dts";
	//soundProfile = rocketExplodeSound;

	lifeTimeMS = 350;

	particleEmitter = magic_fireEmitter;
	particleDensity = 10;
	particleRadius = 0.2;

	//emitter[0] = rocketExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "6.0 7.0 6.0";
	camShakeAmp = "1.0 5.0 1.0";
	camShakeDuration = 0.3;
	camShakeRadius = 15.0;

	// Dynamic light
	lightStartRadius = 10;
	lightEndRadius = 25;
	lightStartColor = "1 0.5 0 1";
	lightEndColor = "0 0 0 1";

	damageRadius = 3;
	radiusDamage = 30;

	impulseRadius = 5;
	impulseForce = 200;
};

datablock ExplosionData(magic_iceballExplosion)
{
	//explosionShape = "./explosionSphere1.dts";
	//soundProfile = rocketExplodeSound;

	lifeTimeMS = 350;

	particleEmitter = magic_iceEmitter;
	particleDensity = 30;
	particleRadius = 0.2;

	//emitter[0] = rocketExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "6.0 7.0 6.0";
	camShakeAmp = "1.0 5.0 1.0";
	camShakeDuration = 0.3;
	camShakeRadius = 15.0;

	// Dynamic light
	lightStartRadius = 5;
	lightEndRadius = 10;
	lightStartColor = "0.1 0.5 1.0 1";
	lightEndColor = "0 0 0 1";

	damageRadius = 1;
	radiusDamage = 10;

	impulseRadius = 5;
	impulseForce = 200;
};

datablock ExplosionData(magic_DarkballExplosion)
{
	//explosionShape = "./explosionSphere1.dts";
	//soundProfile = rocketExplodeSound;

	lifeTimeMS = 350;

	particleEmitter = magic_DarkEmitter;
	particleDensity = 20;
	particleRadius = 1.0;

	//emitter[0] = rocketExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "6.0 7.0 6.0";
	camShakeAmp = "1.0 5.0 1.0";
	camShakeDuration = 0.3;
	camShakeRadius = 15.0;

	// Dynamic light
	lightStartRadius = 20;
	lightEndRadius = 5;
	lightStartColor = "0.0 0.0 0.0 1";
	lightEndColor = "0 0 0 1";

	damageRadius = 0.5;
	radiusDamage = 100;

	impulseRadius = 0;
	impulseForce = 0;
};

datablock ExplosionData(magic_LightballExplosion)
{
	//explosionShape = "./explosionSphere1.dts";
	//soundProfile = rocketExplodeSound;

	lifeTimeMS = 700;

	particleEmitter = magic_LightEmitter;
	particleDensity = 50;
	particleRadius = 3.0;

	//emitter[0] = rocketExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "6.0 7.0 6.0";
	camShakeAmp = "1.0 5.0 1.0";
	camShakeDuration = 0.3;
	camShakeRadius = 15.0;

	// Dynamic light
	lightStartRadius = 30;
	lightEndRadius = 0;
	lightStartColor = "1.0 1.0 1.0 1";
	lightEndColor = "1.0 1.0 0.6 1";

	damageRadius = 10;
	radiusDamage = 60;

	impulseRadius = 0;
	impulseForce = 0;
};

//Projectiles

AddDamageType("FireballDirect",   '<bitmap:add-ons/system_modspells/resources/CI_Fire> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Fire> %1',1,1);
AddDamageType("FireballRadius",   '<bitmap:add-ons/system_modspells/resources/CI_Fire> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Fire> %1',1,0);
datablock ProjectileData(magic_fireball)
{
   projectileShapeName = "./resources/fireball/ball.dts";
   directDamage        = 60;
   directDamageType = $DamageType::FireballDirect;
   radiusDamageType = $DamageType::FireballRadius;
   impactImpulse	   = 50;
   verticalImpulse	   = 25;
   explosion           = magic_fireballExplosion;
   particleEmitter     = magic_fireEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;             
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = "";

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 2500;
   fadeDelay           = 2250;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Fireball";
};

AddDamageType("IceBallDirect",   '<bitmap:add-ons/system_modspells/resources/CI_Ice> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Ice> %1',1,1);
AddDamageType("IceBallRadius",   '<bitmap:add-ons/system_modspells/resources/CI_Ice> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Ice> %1',1,0);
datablock ProjectileData(magic_Iceball)
{
   projectileShapeName = "./resources/iceball/ball.dts";
   directDamage        = 30;
   directDamageType = $DamageType::IceballDirect;
   radiusDamageType = $DamageType::IceballRadius;
   impactImpulse	   = 100;
   verticalImpulse	   = 25;
   explosion           = magic_IceballExplosion;
   particleEmitter     = magic_IceEmitter;

   brickExplosionRadius = 2;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;             
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = "glassExplosionSound";

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 2500;
   fadeDelay           = 2250;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Iceball";
};

AddDamageType("DarkBallDirect",   '<bitmap:add-ons/system_modspells/resources/CI_Dark> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Dark> %1',1,1);
AddDamageType("DarkBallRadius",   '<bitmap:add-ons/system_modspells/resources/CI_Dark> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Dark> %1',1,0);
datablock ProjectileData(magic_Darkball)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 100;
   directDamageType = $DamageType::DarkBallDirect;
   radiusDamageType = $DamageType::DarkBallRadius;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = magic_DarkballExplosion;
   particleEmitter     = magic_DarkEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = "";

   muzzleVelocity      = 40;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 1000;
   fadeDelay           = 800;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.0 0.0 0.0";

   uiName = "Darkball";
};

AddDamageType("LightBallDirect",   '<bitmap:add-ons/system_modspells/resources/CI_Light> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Light> %1',1,1);
AddDamageType("LightBallRadius",   '<bitmap:add-ons/system_modspells/resources/CI_Light> %1',    '%2 <bitmap:add-ons/system_modspells/resources/CI_Light> %1',1,0);
datablock ProjectileData(magic_Lightball)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 40;
   directDamageType = $DamageType::LightBallDirect;
   radiusDamageType = $DamageType::LightBallRadius;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = magic_LightballExplosion;
   particleEmitter     = magic_LightEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;             
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 25;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = "";

   muzzleVelocity      = 40;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 9500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.5;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "1.0 1.0 1.0";

   uiName = "Lightball";
};